When submitting a solution in C++, please select either C++14 (GCC 6-32) or C++17 (GCC 7-32) as your compiler. ×

awoo's blog

By awoo, history, 6 years ago, translation, In English

985A - Chess Placing

Tutorial
Solution (Vovuh)

985B - Switches and Lamps

Tutorial
Solution (Vovuh)

985C - Liebig's Barrels

Tutorial
Solution (adedalic)

985D - Sand Fortress

Tutorial
Solution (PikMike)

985E - Pencils and Boxes

Tutorial
Solution (PikMike)

985F - Isomorphic Strings

Tutorial
Solution (adedalic)

985G - Team Players

Tutorial
Solution (adedalic)
  • Vote: I like it
  • +80
  • Vote: I do not like it

| Write comment?
»
6 years ago, # |
Rev. 2   Vote: I like it +21 Vote: I do not like it

Okay, formulas got better.

»
6 years ago, # |
  Vote: I like it 0 Vote: I do not like it

In problem D, for n=5,H=2, why is [2,3] wrong? I seem to be missing something here

  • »
    »
    6 years ago, # ^ |
      Vote: I like it +29 Vote: I do not like it

    The pillars are infinite. So your example is [2, 3, 0, 0, ...]. The difference between 3 and 0 is beyond 1.

    • »
      »
      »
      6 years ago, # ^ |
      Rev. 2   Vote: I like it 0 Vote: I do not like it

      Ahh damn I knew I was missing something simple. Thanks!

»
6 years ago, # |
  Vote: I like it +5 Vote: I do not like it

Problem D binary search on h the height becomes h,h-1,h-2...2,1,0 and if h>H make it becomes H and change the height on the right too. if H=5 There are two case: 1. [9,8,7,6,5,4,3,2,1,0][ 5,6,7,6,5,4,3,2,1,0] Sum=(9+1)*9/2-(4+2+0...) 2. [8,7,6,5,4,3,2,1,0][5,6,6,5,4,3,2,1,0] Sum=(8+1)*8/2-(3+1+0..) find the smallest h that sum>=n Note: 1+3+..n=[(n+1)/2]^2=tmp 2+4+..n=tmp+n east to calculate

»
6 years ago, # |
Rev. 2   Vote: I like it +5 Vote: I do not like it
»
6 years ago, # |
  Vote: I like it +1 Vote: I do not like it

Can you please explain this- "Otherwise, for each i from 1 to n let's take no more than k smallest staves from this segment in the i-th barrel, but in such way, that there are at least n - i staves left for next barrels."

  • »
    »
    6 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    Every barrel will have atleast one stave from the range [1,rg) otherwise there will be two barrels whose volume difference will be greater than l.

    So for each barrel i from 1 to n, start picking up the staves (smallest first) from [1,rg) until you reach the required number of staves (k) or if there there are fewer than n-i staves left in the range [1,rg) because you still need to build n-i barrels and each of these needs atleast one stave from this range

»
6 years ago, # |
Rev. 4   Vote: I like it 0 Vote: I do not like it

Correct me if I am wrong.

In the first example for problem C:

4 2 1

2 2 1 2 3 2 2 3

Isn't [1, 2], [2, 2], [2, 2], [3, 3] a valid solution with answer 8?

  • »
    »
    6 years ago, # ^ |
    Rev. 2   Vote: I like it +3 Vote: I do not like it

    l = 1, and the volume of your first barrel is equal to 1, and the volume of your fifth is 3,so abs(3-1) is definitely bigger than 1.

»
6 years ago, # |
  Vote: I like it 0 Vote: I do not like it

How the solution for 985A works? what principal/logic is this? I'm struggling to understand.

  • »
    »
    6 years ago, # ^ |
      Vote: I like it +3 Vote: I do not like it

    You have to first sort the positions of the pieces because in one move you can either move left or right. We need to sort the positions to get optimal answer. Now the there are N positions and N/2 pieces. These N/2 pieces can be on black position or on white position since we need to place them in same color. Black positions are odd numbers till N and white pieces are even numbers till N (BWBWBW....BW) . Now the number of steps required by each piece is the absolute difference of required position where it should be and initial position of the piece given in the array. Thats what they have done for N/2 pieces. They are taking the minimum steps when placing in white position and black position.

    My Code : http://codeforces.com/contest/985/submission/38496335

»
6 years ago, # |
  Vote: I like it +8 Vote: I do not like it

In author solution of problem F, is the mt19337 random generator unpredictable enough?

  • »
    »
    6 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    If a seed of generator is fixed, any random generator will generate same sequence every time. So it is necessary to set a seed with diffenent values.

    On the other hand, as author, I would like to have a deterministic solution which will not depend on time it was started.

    • »
      »
      »
      6 years ago, # ^ |
        Vote: I like it 0 Vote: I do not like it

      I guess it is OK to use hash without unpredictable random in author solution (if the hash is strong enough, like the 8-modulo hash in author solution for F). No one beside author can see the solution and generate the anti-hash testcase until the end of the hacking phase.

»
6 years ago, # |
  Vote: I like it 0 Vote: I do not like it

i dont understanf why i am getting TLE in problem C my code

  • »
    »
    6 years ago, # ^ |
    Rev. 3   Vote: I like it +1 Vote: I do not like it

    Java's inbuilt Arrays.sort() uses a double pivot quick-sort whose worst case is O(n^2), So, it can be hacked by a testcase specially designed to break it. Some O(nlogn) sort like Merge sort or heap sort could be used or radix sort. You can also add a random shuffle before Arrays.sort or use Integer instead of int so that java's inbuilt Arrays.sort() over Objects(timsort) will be used.
    TLE with Arrays.sort()-38492535
    AC with Arrays.sort() over Integer- 38524250

    My Java solution also TLEd due to same reason :(

    • »
      »
      »
      6 years ago, # ^ |
        Vote: I like it 0 Vote: I do not like it

      thanxx man, got it!!! and does it only happen in educational rounds or in normal rounds we should take care of Arrays.sort()

      • »
        »
        »
        »
        6 years ago, # ^ |
          Vote: I like it +1 Vote: I do not like it

        Usually normal rounds are of small length, so this kind of hacks rarely happen. But creating a custom sort function which first randomly shuffles the array and then sorts or some other sort should be on the safer side.

»
6 years ago, # |
  Vote: I like it +4 Vote: I do not like it

Can Somebody explain DP part of Solution E

  • »
    »
    6 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    Same question xD

  • »
    »
    6 years ago, # ^ |
      Vote: I like it +9 Vote: I do not like it

    Also, Necrozma

    Maybe the code of O(n2) solution will help a bit more?

    Code
    • »
      »
      »
      6 years ago, # ^ |
      Rev. 2   Vote: I like it 0 Vote: I do not like it

      Hey, by checking i+1-j>=k, you basically check if i and j can be taken in a segment, what if the jth is already taken in some previous segment and taking i,j together "disturbs" it?

      • »
        »
        »
        »
        6 years ago, # ^ |
        Rev. 2   Vote: I like it +7 Vote: I do not like it

        You update from dpj and that is the state for the first j elements being distributed. j-th element is the first one not taken.

        • »
          »
          »
          »
          »
          6 years ago, # ^ |
            Vote: I like it 0 Vote: I do not like it

          Please can you explain the use of array f[N] . I am not able to understand.

»
6 years ago, # |
  Vote: I like it 0 Vote: I do not like it

can anybody help in understanding div 2 C,i havent got the idea n-i stacks to be left for each i??

  • »
    »
    6 years ago, # ^ |
    Rev. 2   Vote: I like it 0 Vote: I do not like it

    First, sort array in non-decreasing order.

    We must have a barrel which contains a1 stave. So each maximal total sum of volumes of barrel cannot be larger than a1 + l

    let C = (number of stave which has length  ≤ a1 + l) - N.

    If C < 0, then answer is 0.

    Otherwise, While picking staves, if C > 0, pick the smallest stave you have, and decrease C by 1. else, pick the largest stave you have.

»
6 years ago, # |
  Vote: I like it 0 Vote: I do not like it

How to solve F with LCP?

»
6 years ago, # |
  Vote: I like it +3 Vote: I do not like it

awoo, Can u give me any practice problem link similar to DP involved in Problem E?
P.S : I am new to DP.

  • »
    »
    6 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    Huh, you know, this is such a basic dp usage. No particular problem comes to my head. I can recommend to search some dp trains on e-olymp, they have lots of great contests on certain topics.

»
6 years ago, # |
  Vote: I like it 0 Vote: I do not like it

Well it is annoying that the third problem WA on test 13

»
6 years ago, # |
Rev. 2   Vote: I like it +3 Vote: I do not like it

in problem F. More over, if we sort all positions posis for all distict characters in s and sort all positions posjt for t, then posis must be equal posit for any i.

can someone expalain this?

  • »
    »
    6 years ago, # ^ |
      Vote: I like it +5 Vote: I do not like it

    If both strings are isomorphic, then the first occurrence of character X in S MUST be the first occurrence of some character Y in T.

    So if you sort the positions of first occurrences of distinct letters for S and T, they will be exactly same (only if they are isomorphic, also the reverse might not be true).

»
6 years ago, # |
  Vote: I like it 0 Vote: I do not like it

About problem 985E — Pencils and Boxes. I was thinking about proof. For "YES" condition its fairly simple. But what about "NO". Can'nt we get other segments. other than what is describe by DP solution.

  • »
    »
    6 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    Usually, there is next idea behind this type of task: (solution exists)  →  (author solution finds answer) !(author solution finds answer)  →  !(solution exists).

»
5 years ago, # |
  Vote: I like it 0 Vote: I do not like it

Another approach in problem E is to first sort the whole array. My approach- https://codeforces.com/contest/985/submission/54277798 Now start from back, I am using 0 based indexing, now mem[j] stores if from index j, I can have a soln. or not. Base case is mem[n]=1 and mem[j] can be known as we need to know nearest location after k indexes from where mem[i]==1. or just look at my soln.- In my soln. mem[j] stores if from index j ican construct a soln. or not. nr[j] stores nearest index >=j where mem[i]==1.

»
5 years ago, # |
  Vote: I like it 0 Vote: I do not like it

can anyone please help me in A problem...how you come up with the idea of this formula

»
5 years ago, # |
  Vote: I like it 0 Vote: I do not like it

In second question if you enter 2x3 matrix 1 1 0 0 1 1 so answer will be yes or no ???

Tutorial's code give yes but answer will be no!!

  • »
    »
    5 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    answer is "no" obviusly, and the tutorial code also gives "no"

    • »
      »
      »
      5 years ago, # ^ |
        Vote: I like it 0 Vote: I do not like it

      Tutorial c9de gives yes

    • »
      »
      »
      5 years ago, # ^ |
        Vote: I like it 0 Vote: I do not like it

      You can check it

      • »
        »
        »
        »
        5 years ago, # ^ |
          Vote: I like it 0 Vote: I do not like it

        i've checked. it gives no

        • »
          »
          »
          »
          »
          5 years ago, # ^ |
            Vote: I like it 0 Vote: I do not like it

          ohhh really it gives yes i checked it again

          • »
            »
            »
            »
            »
            »
            5 years ago, # ^ |
              Vote: I like it 0 Vote: I do not like it

            i checked it 4 times and it gives no

            • »
              »
              »
              »
              »
              »
              »
              5 years ago, # ^ |
                Vote: I like it 0 Vote: I do not like it

              input is 2 3 1 1 0 0 1 1 ????

              • »
                »
                »
                »
                »
                »
                »
                »
                5 years ago, # ^ |
                  Vote: I like it +3 Vote: I do not like it

                input is

                2 3
                110
                011
                
                • »
                  »
                  »
                  »
                  »
                  »
                  »
                  »
                  »
                  5 years ago, # ^ |
                    Vote: I like it 0 Vote: I do not like it

                  there is 2 switch if you you on only one switch how it posible all lamps on.

»
4 years ago, # |
  Vote: I like it 0 Vote: I do not like it

Can someone explain to me how the O(n^2) solution is working in case of ProbE Pencils and Boxes? I am facing a lot of difficulty in understanding how the given solution is taking care of the constraint that every box contains at least k elements.

»
4 years ago, # |
Rev. 3   Vote: I like it 0 Vote: I do not like it

I have an alternate (simpler?) solution to $$$Problem D$$$: we binary search over the answer:

Can $$$x$$$ be the answer? First, notice monotonicity of this boolean upto $$$x \leq n$$$. Now, lets fill up the range with maximum possible stones (can be found by easy math). It will be obviously of the form $$$h_1 ≤ h_2 ≤ ... ≤ h_k ≥ ...\geq1=h_x$$$. If the sum of $$$h_i$$$ is less than $$$n$$$, obviously NO $$$x$$$ can't be the answer. Otherwise, we prove by construction, that it is.

For while $$$n$$$ is less than sum, decrease the sum by $$$1$$$ by removing one from the height of the greatest pile. It obviously maintains the invariant $$$|h_i-h_{i+1}|\leq1$$$.

»
2 years ago, # |
  Vote: I like it 0 Vote: I do not like it

My $$$\mathcal{O} (N \log N A)$$$ TLEs. Interesting that authors made such tight constraints (easily fixable).